'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = function (_ref) {
  var t = _ref.types;

  var routeFnIdentifier = void 0;
  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(path) {
        var isRouteImport = path.node.source.value === ROUTE_IMPORT_VALUE;
        var isDefaultImport = t.isImportDefaultSpecifier(path.node.specifiers[0]);

        if (isRouteImport && isDefaultImport) {
          routeFnIdentifier = path.node.specifiers[0].local.name;
        }
      },
      CallExpression: function CallExpression(path, state) {
        var routeBinding = path.scope.bindings[routeFnIdentifier];
        var isRouteCallee = path.node.callee.name === routeFnIdentifier;
        var isModule = routeBinding ? routeBinding.kind === 'module' : null;

        if (isRouteCallee && isModule) {
          var _path$node$arguments = _slicedToArray(path.node.arguments, 2);

          var nameArg = _path$node$arguments[0];
          var pathArg = _path$node$arguments[1];

          var isNameString = t.isStringLiteral(nameArg);
          var isPathString = t.isStringLiteral(pathArg);

          if (path.node.arguments.length > 2) {
            _logger2.default.warn(createFileMessage('Too many arguments on ' + routeFnIdentifier + ' function', path, state));
          }

          if (!isNameString || !isPathString) {
            _logger2.default.error(createFileMessage('Arguments to the ' + routeFnIdentifier + ' function must be string literals', path, state));
            return;
          }

          state.file.metadata.vtexRender = {
            route: {
              name: nameArg.value,
              path: pathArg.value
            }
          };
        }
      }
    }
  };
};

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ROUTE_IMPORT_VALUE = 'vtex.renderjs/route.js';

function createFileMessage(message, path, state) {
  var filename = state.file.opts.filename;
  var loc = path.node.loc;

  return message + ' on ' + filename + ' (' + loc.start.line + ':' + loc.start.column + ')';
}